# SPDX-FileCopyrightText: Copyright © 2023 Idiap Research Institute <contact@idiap.ch>
#
# SPDX-License-Identifier: GPL-3.0-or-later

"""Tests for the aggregated Montgomery-Shenzhen-Indian-Padchest(TB) dataset."""

import pytest


@pytest.mark.skip(reason="Test need to be updated")
def test_dataset_consistency():
    from ptbench.configs.datasets.indian_RS import default as in_RS
    from ptbench.configs.datasets.mc_ch_in_pc_RS import default as mc_ch_in_pc
    from ptbench.configs.datasets.montgomery_RS import default as mc_RS
    from ptbench.configs.datasets.padchest_RS import tb_idiap as pc_RS
    from ptbench.configs.datasets.shenzhen_RS import default as ch_RS

    # Default protocol
    mc_ch_in_pc_dataset = mc_ch_in_pc.dataset
    assert isinstance(mc_ch_in_pc_dataset, dict)

    mc_RS_dataset = mc_RS.dataset
    ch_RS_dataset = ch_RS.dataset
    in_RS_dataset = in_RS.dataset
    pc_RS_dataset = pc_RS.dataset

    assert "train" in mc_ch_in_pc_dataset
    assert len(mc_ch_in_pc_dataset["train"]) == len(
        mc_RS_dataset["train"]
    ) + len(ch_RS_dataset["train"]) + len(in_RS_dataset["train"]) + len(
        pc_RS_dataset["train"]
    )

    assert "validation" in mc_ch_in_pc_dataset
    assert len(mc_ch_in_pc_dataset["validation"]) == len(
        mc_RS_dataset["validation"]
    ) + len(ch_RS_dataset["validation"]) + len(
        in_RS_dataset["validation"]
    ) + len(
        pc_RS_dataset["validation"]
    )

    assert "test" in mc_ch_in_pc_dataset
    assert len(mc_ch_in_pc_dataset["test"]) == len(mc_RS_dataset["test"]) + len(
        ch_RS_dataset["test"]
    ) + len(in_RS_dataset["test"]) + len(pc_RS_dataset["test"])
